/**************************************************************** 
 * Description: 洛谷 P1016
 * 贪心算法
 * Author: Alex Li
 * Date: 2023-06-18 20:35:46
 * LastEditTime: 2024-01-22 15:12:06
****************************************************************/


#include<iostream>
#include<algorithm> // 包含标准库算法头文件，用于后面的sort函数
using namespace std;

// 定义一个结构体，用来存储油站信息
struct node{
    double wei,p ; // wei表示油站距离出发点的距离，p表示油价
};

double d1,c,d2,you,w; // 分别表示目的地距离、油箱容量、每升油能行驶的距离、油量和临时变量
double ans ; // 存储总费用
int n,x,k; // n表示油站数，x表示当前位置索引，k用于内部循环
double y,mi ; // y表示当前油量能到达的最远距离，mi存储最低油价
node a[1000011] ; // 存储油站信息的数组
bool f,ff ; // 标记变量，f用于判断是否有油站，ff用于判断是否找到更便宜的油价

// 比较函数，用于排序油站
bool cmp(node a,node b) 
{
    return a.wei < b.wei ;
}

int main() 
{
    // 读入数据
    scanf("%lf%lf%lf%lf%d",&d1,&c,&d2,&a[0].p,&n) ;
    a[0].wei = 0 ; // 出发点设置为第一个点
    for(int i=1; i<=n; i++) 
    {
        scanf("%lf%lf",&a[i].wei,&a[i].p) ; // 读入油站信息
    }
    sort(a+1, a+n+1, cmp) ; // 根据距离对油站进行排序
    a[++n].wei = d1 ; // 将目的地作为最后一个“油站”
    a[n].p = 0 ; // 目的地油价设为0
    x = 0 ; // 出发点索引
    while(x < n) // 当还未到达目的地时循环
    {
        mi = 1000000000 ; // 初始化最小油价
        y = a[x].wei + d2 * c ; // 计算当前油量能到达的最远距离
        f = false ; ff = false ;
        for(int i = x+1; x <= n && a[i].wei <= y; i++) 
        {
            f = true ; // 标记存在油站
            if(a[i].p <= a[x].p)
            {
                k = i ;
                w = (a[i].wei-a[x].wei) / d2 ;
                if(you >= w) 
                {
                    you -= w ;
                }
                else 
                {
                    ans += (w - you) * a[x].p ;
                    you = 0 ;
                }
                x = i ;
                ff = true ; // 标记找到更便宜的油价
                break ;
            }
            if(a[i].p < mi) mi = a[i].p, k = i ; // 记录最低油价和对应油站
        }
        if(ff) continue ; // 如果找到更便宜的油价则继续
        if(!f) // 如果没有油站则输出No Solution
        {
            printf("No Solution\n") ;
            return 0 ;
        }
        ans += (c - you) * a[x].p ; // 加油到满
        you = c - (a[k].wei - a[x].wei) / d2 ; // 计算新的油量
        x = k ; // 更新位置        
    }
    printf("%.2lf", ans) ; // 输出总费用
    return 0 ;
}
